/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreUmlsRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreUmls extends TableImpl<VCoreUmlsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_umls</code>
     */
    public static final VCoreUmls V_CORE_UMLS = new VCoreUmls();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreUmlsRecord> getRecordType() {
        return VCoreUmlsRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_umls.dn</code>.
     */
    public final TableField<VCoreUmlsRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_umls.umlscode</code>.
     */
    public final TableField<VCoreUmlsRecord, String> UMLSCODE = createField(DSL.name("umlscode"), SQLDataType.CLOB, this, "");

    private VCoreUmls(Name alias, Table<VCoreUmlsRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreUmls(Name alias, Table<VCoreUmlsRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_umls" as  WITH x(e) AS (
                SELECT jsonb_array_elements(v_core_umlsimport.content) AS jsonb_array_elements
                  FROM common_dd.v_core_umlsimport
               )
        SELECT (e ->> 'value'::text) AS dn,
           (jsonb_array_elements(((e ->> 'concepts'::text))::jsonb) ->> 'concept'::text) AS umlscode
          FROM x
         GROUP BY (e ->> 'value'::text), (jsonb_array_elements(((e ->> 'concepts'::text))::jsonb) ->> 'concept'::text);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_umls</code> table reference
     */
    public VCoreUmls(String alias) {
        this(DSL.name(alias), V_CORE_UMLS);
    }

    /**
     * Create an aliased <code>common_dd.v_core_umls</code> table reference
     */
    public VCoreUmls(Name alias) {
        this(alias, V_CORE_UMLS);
    }

    /**
     * Create a <code>common_dd.v_core_umls</code> table reference
     */
    public VCoreUmls() {
        this(DSL.name("v_core_umls"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreUmls as(String alias) {
        return new VCoreUmls(DSL.name(alias), this);
    }

    @Override
    public VCoreUmls as(Name alias) {
        return new VCoreUmls(alias, this);
    }

    @Override
    public VCoreUmls as(Table<?> alias) {
        return new VCoreUmls(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUmls rename(String name) {
        return new VCoreUmls(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUmls rename(Name name) {
        return new VCoreUmls(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUmls rename(Table<?> name) {
        return new VCoreUmls(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmls where(Condition condition) {
        return new VCoreUmls(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmls where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmls where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmls where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmls where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmls where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmls where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmls where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmls whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmls whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
